﻿; (function () {
	'use strict';
	var total = 0;
	var loadedCount = 0;
	var paths = [];
	var verDic;
	var defaultVer = 1;
	var resVersion;
	var list = [];
	var isPublish = false;

	let platformName = "bh";
	let platformCfg;
	loadGameCfg();
	function loadGameCfg() {
		console.log("开始加载游戏配置");
		var xhr = new XMLHttpRequest();
		xhr.open('GET', './platformCfg/' + platformName +'.json?v=' + new Date().getTime(), true);
		xhr.addEventListener("load", function () {
			var cfg = JSON.parse(xhr.response);
			if (!cfg) {
				alert("配置异常");
			}
			platformCfg = cfg;
			window["GAME_CONFIG"] = cfg;
			console.log(JSON.stringify(cfg));
			$loadStart();
		});
		xhr.addEventListener("readystatechange", function (obj) {
			console.log("加载状态" + xhr.readyState, xhr.status);
			if (xhr.readyState == 4) {
				if (xhr.status != 200) {
					alert("配置加载失败");
				}
			}
		});
		xhr.send(null);
	};

	function $loadStart() {
		var cfg = window["GAME_CONFIG"];
		isPublish = cfg["isPublish"];
		resVersion = cfg.resVer;
		
		list = ["js/core.js","js/proto.js","js/rpg.js","js/logic.js"];
		total = list.length;
		if(isPublish){
			$loadVerCfg();
		} else {
			for(var i = 0; i < total; i ++){
				paths.push(list[i]);
			}
			loadJS();
		}
	};

	function $loadVerCfg(){
		var verDicPath = "ver/" + resVersion + "/version.json?_t=" + (new Date() - 0);
		var xhr = new XMLHttpRequest();
		xhr.open('GET', verDicPath, true);
		xhr.addEventListener("load", function ()
		{
			var vers = JSON.parse(xhr.response);
			console.log(JSON.stringify(vers));
			window["verJson"] = vers;
			verDic = vers.verDic;
			defaultVer = vers.defaultVer;
			var finalJsFilePath;

			var ln = list.length;
			var jsVer;
			for (var i = 0; i < ln; i++)
			{
				var jsFilePath = list[i];
				jsVer = defaultVer;
				if (verDic[jsFilePath])
				{
					jsVer = verDic[jsFilePath];
				}
				finalJsFilePath = "ver/" + jsVer +"/" + jsFilePath;
				paths.push(finalJsFilePath);
			}
			
			loadJS();
		});
		xhr.send(null);
	};

	function loadJS() {
		loadedCount = 0;
		while(paths.length > 0){
			var url = paths.shift();
			loadScript(url);
		}
	};
	
	function loadScript(url) {
		var script = document.createElement('script');
		script.type = 'text/javascript';
		script.src = url;
		script.onload = ()=>{
			console.log("脚本加载成功："+url);
			loadedCount ++;
			// script.parentNode.removeChild(script);
			if(loadedCount == total){
				console.log("脚本全部加载完成");
				gameRun();
			}
		}
		var head = document.getElementsByTagName('head')[0];
		head.appendChild(script);
	};
	
	function gameRun(){
		console.log("===开始初始化游戏程序===");
		new Main();
	}
})();
